let
  vlansPlan = mgmt: {
    "uplink-cri".ids = 223;

    "admin-core" = {
      ids = 3000;
      management = mgmt;
    };
    "admin-ap".ids = 3001;
    "users".ids = [
      {
        begin = 3045;
        end = 4094;
      }
    ];

    "ap-staging".ids = 2000;
  };
  AP = {
    enable = true;
    interface-mode = "trunk";
    vlans = [
      "users"
      "admin-ap"
    ];
  };
  AP-staging = {
    enable = true;
    interface-mode = "access";
    vlans = [ "ap-staging" ];
  };
in
{
  netcore01 = {
    deployement.targetHost = "jourdan01.dgn";

    vlans = vlansPlan "fd26:baf9:d250:8000::1001/64";
    interfaces = {
      "ge-0/0/12" = AP;
      "ge-0/0/13" = AP;
      "ge-0/0/14" = AP;
      "ge-0/0/15" = AP;
      "ge-0/0/16" = AP;
      "ge-0/0/17" = AP;

      "ge-0/0/42" = {
        enable = true;
        interface-mode = "access";
        vlans = [ "admin-core" ];
      };
      "ge-0/0/43" = AP-staging;
      "ge-0/0/47" = {
        # ilo
        enable = true;
        interface-mode = "access";
        vlans = [ "admin-core" ];
      };

      "xe-0/1/0" = {
        enable = true;
        interface-mode = "trunk";
        vlans = [ "all" ];
        dhcp_trusted = true;
      };
      "xe-0/1/1" = {
        enable = true;
        interface-mode = "trunk";
        vlans = [
          "users"
          "admin-ap"
          "admin-core"
        ];
      };
      "ge-0/1/3" = {
        enable = true;
        interface-mode = "trunk";
        vlans = [ "uplink-cri" ];
      };

      "me0" = {
        enable = true;
        management = "192.168.42.6/24";
      };
    };
  };
  netaccess01 = {
    deployement.targetHost = "root@192.168.42.6";

    vlans = vlansPlan "fd26:baf9:d250:8000::2001/64";
    interfaces = {
      "xe-0/1/0" = {
        enable = true;
        interface-mode = "trunk";
        vlans = [ "all" ];
        dhcp_trusted = true;
      };

      "me0" = {
        enable = true;
        management = "192.168.42.6/24";
      };
    };
  };
}
